library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;


entity ROM_16x7_tb is
    --  Port ( );
end ROM_16x7_tb;

architecture Behavioral of ROM_16x7_tb is
    component ROM_16x7 is
        generic(
            addr_width : integer := 4; -- number of bits in the address
            data_width : integer := 7   -- number of bits in data
        );
        port (
            addr : in std_logic_vector(addr_width-1 downto 0);
            data : out std_logic_vector(data_width-1 downto 0)
        );
    end component;

    constant ADDR_WIDTH_CONST: integer := 4;
    constant DATA_WIDTH_CONST: integer := 7;
    signal addr: std_logic_vector(ADDR_WIDTH_CONST-1 downto 0);
    signal data: std_logic_vector(DATA_WIDTH_CONST-1 downto 0);
    
    constant DELAY : time := 10 ns;
begin

    UUT: ROM_16x7
        generic map (
            addr_width => ADDR_WIDTH_CONST, 
            data_width => DATA_WIDTH_CONST
        )
        port map (
            addr => addr,
            data => data
        );
        
    STIM: process
    begin
        for ii in 0 to 16 loop
            addr <= std_logic_vector(to_unsigned(ii, addr'length));
            wait for DELAY;
        end loop;
        wait;
    end process;

end Behavioral;
